<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml" lang="" xml:lang="">
<head>
  <meta charset="utf-8" />
  <meta name="generator" content="pandoc" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0, user-scalable=yes" />
  <title>README</title>
  <style type="text/css">
      code{white-space: pre-wrap;}
      span.smallcaps{font-variant: small-caps;}
      span.underline{text-decoration: underline;}
      div.column{display: inline-block; vertical-align: top; width: 50%;}
  </style>
  <style type="text/css">
a.sourceLine { display: inline-block; line-height: 1.25; }
a.sourceLine { pointer-events: none; color: inherit; text-decoration: inherit; }
a.sourceLine:empty { height: 1.2em; }
.sourceCode { overflow: visible; }
code.sourceCode { white-space: pre; position: relative; }
div.sourceCode { margin: 1em 0; }
pre.sourceCode { margin: 0; }
@media screen {
div.sourceCode { overflow: auto; }
}
@media print {
code.sourceCode { white-space: pre-wrap; }
a.sourceLine { text-indent: -1em; padding-left: 1em; }
}
pre.numberSource a.sourceLine
  { position: relative; left: -4em; }
pre.numberSource a.sourceLine::before
  { content: attr(title);
    position: relative; left: -1em; text-align: right; vertical-align: baseline;
    border: none; pointer-events: all; display: inline-block;
    -webkit-touch-callout: none; -webkit-user-select: none;
    -khtml-user-select: none; -moz-user-select: none;
    -ms-user-select: none; user-select: none;
    padding: 0 4px; width: 4em;
    color: #aaaaaa;
  }
pre.numberSource { margin-left: 3em; border-left: 1px solid #aaaaaa;  padding-left: 4px; }
div.sourceCode
  {  }
@media screen {
a.sourceLine::before { text-decoration: underline; }
}
code span.al { color: #ff0000; font-weight: bold; } /* Alert */
code span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code span.at { color: #7d9029; } /* Attribute */
code span.bn { color: #40a070; } /* BaseN */
code span.bu { } /* BuiltIn */
code span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code span.ch { color: #4070a0; } /* Char */
code span.cn { color: #880000; } /* Constant */
code span.co { color: #60a0b0; font-style: italic; } /* Comment */
code span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code span.do { color: #ba2121; font-style: italic; } /* Documentation */
code span.dt { color: #902000; } /* DataType */
code span.dv { color: #40a070; } /* DecVal */
code span.er { color: #ff0000; font-weight: bold; } /* Error */
code span.ex { } /* Extension */
code span.fl { color: #40a070; } /* Float */
code span.fu { color: #06287e; } /* Function */
code span.im { } /* Import */
code span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
code span.kw { color: #007020; font-weight: bold; } /* Keyword */
code span.op { color: #666666; } /* Operator */
code span.ot { color: #007020; } /* Other */
code span.pp { color: #bc7a00; } /* Preprocessor */
code span.sc { color: #4070a0; } /* SpecialChar */
code span.ss { color: #bb6688; } /* SpecialString */
code span.st { color: #4070a0; } /* String */
code span.va { color: #19177c; } /* Variable */
code span.vs { color: #4070a0; } /* VerbatimString */
code span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
  </style>
</head>
<body>
<h1 id="wasm-event-loop">wasm-event-loop</h1>
<p><a href="https://stackblitz.com/edit/wasm-event-loop">Edit on StackBlitz ⚡️</a></p>
<p>This is a demo of promises + closures inside WebAssembly. The sample implements an async function that sums values from two async other async functions.</p>
<p>Pseudo-code of async sum in WebAssembly</p>
<div class="sourceCode" id="cb1"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb1-1" title="1"><span class="im">import</span> <span class="op">{</span>getX<span class="op">,</span> getY<span class="op">}</span> <span class="im">from</span> <span class="st">&#39;./external.js&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb1-2" title="2"></a>
<a class="sourceLine" id="cb1-3" title="3"><span class="im">export</span> <span class="kw">async</span> <span class="kw">function</span> <span class="at">sum</span>()<span class="op">:</span> i32 <span class="op">{</span></a>
<a class="sourceLine" id="cb1-4" title="4">  <span class="kw">const</span> <span class="dt">xValue</span><span class="op">:</span> i32 <span class="op">=</span> <span class="cf">await</span> <span class="at">getX</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-5" title="5">  <span class="kw">const</span> <span class="dt">yValue</span><span class="op">:</span> i32 <span class="op">=</span> <span class="cf">await</span> <span class="at">getY</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb1-6" title="6">  <span class="cf">return</span> xValue <span class="op">+</span> yValue<span class="op">;</span></a>
<a class="sourceLine" id="cb1-7" title="7"><span class="op">}</span></a></code></pre></div>
<p>…as promises</p>
<div class="sourceCode" id="cb2"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb2-1" title="1"><span class="im">import</span> <span class="op">{</span>getX<span class="op">,</span> getY<span class="op">}</span> <span class="im">from</span> <span class="st">&#39;./external.js&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb2-2" title="2"></a>
<a class="sourceLine" id="cb2-3" title="3"><span class="im">export</span> <span class="kw">function</span> <span class="at">sum</span>()<span class="op">:</span> Promise<span class="op">&lt;</span>i32<span class="op">&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-4" title="4">  <span class="cf">return</span> <span class="at">getX</span>()</a>
<a class="sourceLine" id="cb2-5" title="5">    .<span class="at">then</span>((<span class="kw">const</span> <span class="dt">xValue</span><span class="op">:</span> i32) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-6" title="6">      <span class="cf">return</span> <span class="at">getY</span>()</a>
<a class="sourceLine" id="cb2-7" title="7">        .<span class="at">then</span>((<span class="kw">const</span> <span class="dt">yValue</span><span class="op">:</span> i32) <span class="kw">=&gt;</span> <span class="op">{</span></a>
<a class="sourceLine" id="cb2-8" title="8">          <span class="cf">return</span> xValue <span class="op">+</span> yValue<span class="op">;</span></a>
<a class="sourceLine" id="cb2-9" title="9">        <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-10" title="10">    <span class="op">}</span>)<span class="op">;</span></a>
<a class="sourceLine" id="cb2-11" title="11"><span class="op">}</span></a></code></pre></div>
<p>…closures converted to functions</p>
<div class="sourceCode" id="cb3"><pre class="sourceCode js"><code class="sourceCode javascript"><a class="sourceLine" id="cb3-1" title="1"><span class="im">import</span> <span class="op">{</span>createContext<span class="op">,</span> setScopeValue<span class="op">,</span> getScopeValue<span class="op">,</span> deleteContext<span class="op">}</span> <span class="im">from</span> <span class="st">&#39;./closure.js&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-2" title="2"><span class="im">import</span> <span class="op">{</span>then<span class="op">,</span> resolve<span class="op">}</span> <span class="im">from</span> <span class="st">&#39;./promise.js&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-3" title="3"><span class="im">import</span> <span class="op">{</span>getX<span class="op">,</span> getY<span class="op">}</span> <span class="im">from</span> <span class="st">&#39;./external.js&#39;</span><span class="op">;</span></a>
<a class="sourceLine" id="cb3-4" title="4"></a>
<a class="sourceLine" id="cb3-5" title="5"><span class="im">export</span> <span class="kw">function</span> <span class="at">sum</span>()<span class="op">:</span> i32 <span class="op">{</span> <span class="co">// i32 is pointer to promise</span></a>
<a class="sourceLine" id="cb3-6" title="6">  <span class="kw">const</span> xPromise <span class="op">=</span> <span class="at">getX</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb3-7" title="7">  <span class="kw">const</span> sumClosure1ContextPointer <span class="op">=</span> <span class="at">createContext</span>(sumClosure1)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-8" title="8">  <span class="cf">return</span> <span class="at">then</span>(xPromise<span class="op">,</span> sumClosure1ContextPointer)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-9" title="9"><span class="op">}</span></a>
<a class="sourceLine" id="cb3-10" title="10"></a>
<a class="sourceLine" id="cb3-11" title="11"><span class="im">export</span> <span class="kw">function</span> <span class="at">sumClosure1</span>(sumClosure1ContextPointer<span class="op">:</span> i32<span class="op">,</span> xValue<span class="op">:</span> i32)<span class="op">:</span> i32 <span class="op">{</span></a>
<a class="sourceLine" id="cb3-12" title="12">  <span class="at">deleteContext</span>(sumClosure1ContextPointer)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-13" title="13">  <span class="kw">const</span> yPromise <span class="op">=</span> <span class="at">getY</span>()<span class="op">;</span></a>
<a class="sourceLine" id="cb3-14" title="14">  <span class="kw">const</span> sumClosure2ContextPointer <span class="op">=</span> <span class="at">createContext</span>(sumClosure2)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-15" title="15">  <span class="at">setScopei32Value</span>(sumClosure2ContextPointer<span class="op">,</span> <span class="dv">0</span><span class="op">,</span> xValue)</a>
<a class="sourceLine" id="cb3-16" title="16">  <span class="cf">return</span> <span class="at">then</span>(yPromise<span class="op">,</span> sumClosure2ContextPointer)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-17" title="17"><span class="op">}</span></a>
<a class="sourceLine" id="cb3-18" title="18"></a>
<a class="sourceLine" id="cb3-19" title="19"><span class="im">export</span> <span class="kw">function</span> <span class="at">sumClosure2</span>(sumClosure2ContextPointer<span class="op">:</span> i32<span class="op">,</span> yValue<span class="op">:</span> i32)<span class="op">:</span> i32 <span class="op">{</span></a>
<a class="sourceLine" id="cb3-20" title="20">  <span class="kw">const</span> xValue <span class="op">=</span> <span class="at">getScopei32Value</span>(sumClosure2ContextPointer<span class="op">,</span> <span class="dv">0</span>)</a>
<a class="sourceLine" id="cb3-21" title="21">  <span class="at">deleteContext</span>(sumClosure2ContextPointer)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-22" title="22">  <span class="cf">return</span> <span class="at">resolve</span>(xValue <span class="op">+</span> yValue)<span class="op">;</span></a>
<a class="sourceLine" id="cb3-23" title="23"><span class="op">}</span></a></code></pre></div>
</body>
</html>
